var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "fs", "path", "./file-exists", "./write-file"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    const fs_1 = __importDefault(require("fs"));
    const path_1 = require("path");
    const file_exists_1 = __importDefault(require("./file-exists"));
    const write_file_1 = __importDefault(require("./write-file"));
    const copyFile = (source, target) => __awaiter(void 0, void 0, void 0, function* () {
        let targetFile = target;
        // If target is a directory, a new file with the same name will be created
        if (yield (0, file_exists_1.default)(target)) {
            if (fs_1.default.lstatSync(target).isDirectory()) {
                targetFile = (0, path_1.join)(target, (0, path_1.basename)(source));
            }
        }
        yield (0, write_file_1.default)(targetFile, fs_1.default.readFileSync(source, "utf8"));
    });
    exports.default = copyFile;
});
