var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
(function (factory) {
    if (typeof module === "object" && typeof module.exports === "object") {
        var v = factory(require, exports);
        if (v !== undefined) module.exports = v;
    }
    else if (typeof define === "function" && define.amd) {
        define(["require", "exports", "../package.json", "@gluestack-v2/framework-cli/build/plugin/BaseGluestackPlugin", "./PluginInstance", "path"], factory);
    }
})(function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.GlueStackPlugin = void 0;
    // @ts-ignore
    const package_json_1 = __importDefault(require("../package.json"));
    const BaseGluestackPlugin_1 = __importDefault(require("@gluestack-v2/framework-cli/build/plugin/BaseGluestackPlugin"));
    const PluginInstance_1 = require("./PluginInstance");
    const path_1 = __importDefault(require("path"));
    // Do not edit the name of this class
    class GlueStackPlugin extends BaseGluestackPlugin_1.default {
        constructor(app, gluePluginStore) {
            super(app, gluePluginStore);
            this.type = 'devonly';
            this.pluginEnvironment = 'server';
            this.runningPlatforms = [];
        }
        init() {
            //
        }
        destroy() {
            //
        }
        getName() {
            return package_json_1.default.name;
        }
        getVersion() {
            return package_json_1.default.version;
        }
        getType() {
            return this.type;
        }
        // @ts-ignore
        // getTemplateFolderPath(): string {
        //   return join(process.cwd(), 'node_modules', this.getName(), 'template');
        // }
        getInstallationPath(target) {
            return path_1.default.join(this.pluginEnvironment, target);
        }
        getPluginEnvironment() {
            return this.pluginEnvironment;
        }
        runPostInstall(instanceName, target) {
            return __awaiter(this, void 0, void 0, function* () {
                const instance = yield this.app.createPluginInstance(this, instanceName, this.getTemplateFolderPath(), target);
                if (!instance) {
                    return;
                }
                instance.updateSourcePackageJSON();
                instance.updateRootPackageJSONWithSourcePath();
                yield this.app.updateConfigFile(instanceName, 'client');
                // // update package.json'S name index with the new instance name
                // const pluginPackage = `${instance._sourcePath}/package.json`;
                // await reWriteFile(pluginPackage, instanceName, "INSTANCENAME");
                // // update root package.json's workspaces with the new instance name
                // const rootPackage = `${process.cwd()}/package.json`;
                // await Workspaces.append(rootPackage, instance._sourcePath);
            });
        }
        // generateFunctionsInServiceSdk(ignoredPaths: string[]) {
        //   const instances = this.getInstances();
        //   for (const instance of instances) {
        //     const name = instance.getName();
        //     const installationPath = instance._sourcePath;
        //     const plugin = this.app.getPluginByName(
        //       "@gluestack-v2/glue-plugin-service-sdk"
        //     ) as IPlugin;
        //     // @ts-ignore
        //     plugin.generateSDK(installationPath, name, ignoredPaths);
        //   }
        // }
        createInstance(key, gluePluginStore, installationPath) {
            const instance = new PluginInstance_1.PluginInstance(this.app, this, key, gluePluginStore, installationPath);
            this.instances.push(instance);
            return instance;
        }
        getInstances() {
            return this.instances;
        }
    }
    exports.GlueStackPlugin = GlueStackPlugin;
});
